#include "stdafx.h"
#include "wmf.h"

typedef struct _Condition {
	int pattern;
	MAPI::CFolder *pFolder;
	std::wstring key;
} Condition;
typedef std::vector<Condition> Conditions;

enum {
	ePR_ENTRYID,
	ePR_SENDER_EMAIL_ADDRESS,
	ePR_SUBJECT,
	ePR_MESSAGE_FLAGS,
	ePR_COUNT
};
static SizedSPropTagArray(ePR_COUNT, lpTags) = {ePR_COUNT, {
	PR_ENTRYID,
	PR_SENDER_EMAIL_ADDRESS,
	PR_SUBJECT,
	PR_MESSAGE_FLAGS,
}};

int g_AlreadyReadOnly = 0;
Conditions g_Conditions;

void FilterMail(MAPI::CFolder &folder, MAPI::CSession &Session, CIniFile &ini, const Strings &folders);
BOOL EnumMsgFunc(MAPI::CFolder &thisFolder, LPSRow pRow, LPVOID lpParam);

/**
 * tB^OsB
 */
void FilterMail(MAPI::CSession &Session, CIniFile &ini, const Strings &folders)
{
	Values &values = ini.GetValues(_T("target"));
	Values::iterator it;
	for (it = values.begin(); it != values.end(); it++) {
		if (it->first != _T("folder")) continue;

		MAPI::CFolder &folder = Session.GetFolder(it->second);
		FilterMail(folder, Session, ini, folders);
	}
}

void FilterMail(MAPI::CFolder &folder, MAPI::CSession &Session, CIniFile &ini, const Strings &folders)
{
	//[ȂΉȂ
	if (folder.GetAllMessageCount() == 0) return;

	//O[oϐɒlZbg
	g_AlreadyReadOnly = ini.GetIntValue(_T("setting"), _T("alreadyreadonly"));

	Strings::const_iterator it;
	for (it = folders.begin(); it != folders.end(); it++) {
		Values &values = ini.GetValues(*it);
		Values::iterator it2;
		for (it2 = values.begin(); it2 != values.end(); it2++) {
			if (it2->first != _T("pattern")) continue;
			std::wstring::size_type pos = it2->second.find(_T(":"));
			if (pos != std::wstring::npos) {
				Condition cond;
				cond.pattern = _ttoi(it2->second.substr(0, pos).c_str());
				if (cond.pattern < 0 || cond.pattern >= ePR_MESSAGE_FLAGS) continue;
				cond.key = it2->second.substr(pos + 1);
				if (cond.pattern == 0 || cond.key.size() > 0) {
					cond.pFolder = &Session.GetFolder(*it);

					g_Conditions.push_back(cond);
				}
			}
		}
	}

	folder.EnumMessages(EnumMsgFunc, (LPSPropTagArray)&lpTags, NULL);
}

/**
 * 1bZ[W̃tB^OsB
 */
BOOL EnumMsgFunc(MAPI::CFolder &thisFolder, LPSRow pRow, LPVOID lpParam)
{
	//ǃ[͑ΏۂɂȂǂ𔻒
	if (g_AlreadyReadOnly) {
		if (!(pRow->lpProps[ePR_MESSAGE_FLAGS].Value.ul & MSGFLAG_READ)) {
			return TRUE;
		}
	}

	Conditions::iterator it;
	BOOL IsNoMatchMailFilter = FALSE;
	MAPI::CFolder *pNoMatchFolder = NULL;
	for (it = g_Conditions.begin(); it != g_Conditions.end(); it++) {
		if (!IsNoMatchMailFilter && it->pattern == 0) {
			IsNoMatchMailFilter = TRUE;
			pNoMatchFolder = it->pFolder;
			continue;
		}
		LPSPropValue lpProp = &(pRow->lpProps[it->pattern]);
		if (lpTags.aulPropTag[it->pattern] == lpProp->ulPropTag && lpProp->Value.LPSZ != NULL) {
			std::wstring buff = lpProp->Value.LPSZ; 
			if (buff.find(it->key) != std::wstring::npos) {
				if (thisFolder.CopyMessage(pRow->lpProps[ePR_ENTRYID].Value.bin, *(it->pFolder), MESSAGE_MOVE)) {
					g_LastFilterFolder = it->pFolder->GetPath();
					return TRUE;
				} else {
					throw _T("U蕪Ɏs܂B\n𒆒f܂B");
				}
			}
		}
	}

	if (IsNoMatchMailFilter) {
		if (!thisFolder.CopyMessage(pRow->lpProps[ePR_ENTRYID].Value.bin, *pNoMatchFolder, MESSAGE_MOVE)) {
			throw _T("U蕪Ɏs܂B\n𒆒f܂B");
		}
	}

	return TRUE;
}
